/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    app_sys.c
  * @author  MCD Application Team
  * @brief   Application system for STM32WPAN Middleware.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2023 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/

#include "app_sys.h"
#include "app_conf.h"
#include "timer_if.h"
#include "stm32_lpm.h"
#include "ll_intf.h"
#include "ll_sys.h"

#include "ral.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
extern uint32_t llhwc_cmn_is_dp_slp_enabled(void);
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
extern uint8_t is_Radio_DeepSleep;

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/

void APP_SYS_LPM_EnterLowPowerMode(void)
{
  ral_instance_t radio_instance;
  uint8_t channel;
  uint64_t next_radio_evt;

  /* Ensure there are no radio events (implement bsp function like bsp_is_radio_idle() ) */
  ral_event_state_enum_t radio_state = ral_get_current_event_state( &radio_instance, &channel );
  LL_UNUSED(radio_instance);
  LL_UNUSED(channel);
  if (radio_state != RAL_IDLE)
    return;

  next_radio_evt = os_timer_get_earliest_time();
  if ( llhwc_cmn_is_dp_slp_enabled() == 0 )
  {
    if ( next_radio_evt > RADIO_DEEPSLEEP_WAKEUP_TIME_US )
    {
      /* No event in a "near" futur */
      ll_sys_dp_slp_enter( next_radio_evt - RADIO_DEEPSLEEP_WAKEUP_TIME_US );
    }
  }
}

