/**
  ******************************************************************************
  * @file    stm32wba55g_discovery_conf_template.h
  * @author  MCD Application Team
  * @brief   STM32WBA55G_DK1 board configuration file.
  *          This file should be copied to the application folder and renamed
  *          to stm32wba55g_discovery_conf.h .
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2022 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef STM32WBA55G_DK1_CONF_H
#define STM32WBA55G_DK1_CONF_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "stm32wbaxx_hal.h"

/* Usage of STM32WBA55G_DK1 board */
#define USE_STM32WBA55G_DK1      1U

/* COM define */
#define USE_BSP_COM_FEATURE                  1U
#define USE_COM_LOG                          0U

/* IRQ priorities (Default is 15 as lowest priority level) */
#define BSP_AUDIO_OUT_IT_PRIORITY           15U
#define BSP_AUDIO_IN_IT_PRIORITY            15U

#ifdef __cplusplus
}
#endif

#endif /* STM32WBA55G_DK1_CONF_H */

